#!/usr/bin/python
'''
Global variables ... sort of like a config file
'''

DATAPATH = '../data/'
DEBUG = False
SHOW_COLLISIONS = False

MUSICVOLUME = 0.6

# game size-related variables
# if you experience sluggish performance, consider lowering these numbers
FIELDSIZE = 80.0     # size of the game area
HUMANS = 100         # number of humans in game
CARS = 20            # number of cars in game
BUILDING_DENSITY=0.4 # higher values mean more buildings in game: 0.0 - 1.0
BUILDING_SPACING=3.5 # amount of space between buildings. Keep this above 2.0

# difficulty-related variables
ROBO_BLEED = 1.0    # rate at which you lose your ROBO-LIFE
                     # implemented only because I didn't manage to make
                     # real enemies!
                     # setting this to 1.0 should provides 100 seconds of play

ROBO_RECHARGE = 40.0 # how quickly your ROBO-ENERGY recharges
CAR_SPEED = 3.0
HUMAN_SPEED = 1.5
SCORE = {
    'building' : 1,
    'human'    : 2,
    'car'      : 4, 
}

ROBO_COLOR      = (0.6,0,0)
ROBO_EYECOLOR   = ( 0.8, 0.8,   0)
ROBO_LAZORCOLOR = (1.0,0.9,0.4)

ODE_PHYSICS = False  # keep this as False for now